"""
Type annotations for partnercentral-selling service literal definitions.

[Documentation](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_partnercentral_selling/literals/)

Copyright 2025 Vlad Emelianov

Usage::

    ```python
    from mypy_boto3_partnercentral_selling.literals import AwsClosedLostReasonType

    data: AwsClosedLostReasonType = "Administrative"
    ```
"""

import sys

if sys.version_info >= (3, 12):
    from typing import Literal
else:
    from typing_extensions import Literal


__all__ = (
    "AwsClosedLostReasonType",
    "AwsFundingUsedType",
    "AwsMemberBusinessTitleType",
    "AwsOpportunityStageType",
    "ChannelType",
    "ClosedLostReasonType",
    "CompetitorNameType",
    "CountryCodeType",
    "CurrencyCodeType",
    "DeliveryModelType",
    "EngagementContextTypeType",
    "EngagementInvitationPayloadTypeType",
    "EngagementScoreType",
    "EngagementSortNameType",
    "ExpectedCustomerSpendCurrencyCodeEnumType",
    "IndustryType",
    "InvitationStatusType",
    "InvolvementTypeChangeReasonType",
    "ListEngagementByAcceptingInvitationTasksPaginatorName",
    "ListEngagementFromOpportunityTasksPaginatorName",
    "ListEngagementInvitationsPaginatorName",
    "ListEngagementMembersPaginatorName",
    "ListEngagementResourceAssociationsPaginatorName",
    "ListEngagementsPaginatorName",
    "ListOpportunitiesPaginatorName",
    "ListResourceSnapshotJobsPaginatorName",
    "ListResourceSnapshotsPaginatorName",
    "ListSolutionsPaginatorName",
    "ListTasksSortNameType",
    "MarketingSourceType",
    "NationalSecurityType",
    "OpportunityEngagementInvitationSortNameType",
    "OpportunityOriginType",
    "OpportunitySortNameType",
    "OpportunityTypeType",
    "PaginatorName",
    "ParticipantTypeType",
    "PartnerCentralSellingAPIServiceName",
    "PaymentFrequencyType",
    "PrimaryNeedFromAwsType",
    "ReasonCodeType",
    "ReceiverResponsibilityType",
    "RelatedEntityTypeType",
    "ResourceServiceName",
    "ResourceSnapshotJobStatusType",
    "ResourceTypeType",
    "RevenueModelType",
    "ReviewStatusType",
    "SalesActivityType",
    "SalesInvolvementTypeType",
    "ServiceName",
    "SolutionSortNameType",
    "SolutionStatusType",
    "SortByType",
    "SortOrderType",
    "StageType",
    "TaskStatusType",
    "VisibilityType",
)


AwsClosedLostReasonType = Literal[
    "Administrative",
    "Business Associate Agreement",
    "Company Acquired/Dissolved",
    "Competitive Offering",
    "Customer Data Requirement",
    "Customer Deficiency",
    "Customer Experience",
    "Delay / Cancellation of Project",
    "Duplicate",
    "Duplicate Opportunity",
    "Executive Blocker",
    "Failed Vetting",
    "Feature Limitation",
    "Financial/Commercial",
    "Insufficient AWS Value",
    "Insufficient Amazon Value",
    "International Constraints",
    "Legal / Tax / Regulatory",
    "Legal Terms and Conditions",
    "Lost to Competitor",
    "Lost to Competitor - Google",
    "Lost to Competitor - Microsoft",
    "Lost to Competitor - Other",
    "Lost to Competitor - Rackspace",
    "Lost to Competitor - SoftLayer",
    "Lost to Competitor - VMWare",
    "No Customer Reference",
    "No Integration Resources",
    "No Opportunity",
    "No Perceived Value of MP",
    "No Response",
    "No Update",
    "Not Committed to AWS",
    "On Premises Deployment",
    "Other",
    "Other (Details in Description)",
    "Partner Gap",
    "Past Due",
    "People/Relationship/Governance",
    "Platform Technology Limitation",
    "Preference for Competitor",
    "Price",
    "Product Not on AWS",
    "Product/Technology",
    "Security / Compliance",
    "Self-Service",
    "Technical Limitations",
    "Term Sheet Impasse",
]
AwsFundingUsedType = Literal["No", "Yes"]
AwsMemberBusinessTitleType = Literal[
    "AWSAccountOwner", "AWSSalesRep", "ISVSM", "PDM", "PSM", "WWPSPDM"
]
AwsOpportunityStageType = Literal[
    "Building Integration",
    "Business Validation",
    "Closed Incomplete",
    "Closed Lost",
    "Committed",
    "Completed",
    "Contract Negotiation",
    "Deferred to Partner",
    "Engaged",
    "Evaluating",
    "Identified",
    "In Progress",
    "Launched",
    "Not Started",
    "On-hold",
    "Onboarding",
    "Prospect",
    "Qualified",
    "Qualify",
    "Research",
    "Seller Engaged",
    "Seller Registered",
    "Technical Validation",
    "Term Sheet Negotiation",
]
ChannelType = Literal[
    "AWS Marketing Central",
    "Content Syndication",
    "Display",
    "Email",
    "Live Event",
    "Out Of Home (OOH)",
    "Print",
    "Search",
    "Social",
    "TV",
    "Telemarketing",
    "Video",
    "Virtual Event",
]
ClosedLostReasonType = Literal[
    "Customer Deficiency",
    "Customer Experience",
    "Delay / Cancellation of Project",
    "Financial/Commercial",
    "Legal / Tax / Regulatory",
    "Lost to Competitor - Google",
    "Lost to Competitor - Microsoft",
    "Lost to Competitor - Other",
    "Lost to Competitor - SoftLayer",
    "Lost to Competitor - VMWare",
    "No Opportunity",
    "On Premises Deployment",
    "Other",
    "Partner Gap",
    "People/Relationship/Governance",
    "Price",
    "Product/Technology",
    "Security / Compliance",
    "Technical Limitations",
]
CompetitorNameType = Literal[
    "*Other",
    "Akamai",
    "AliCloud",
    "Co-location",
    "Google Cloud Platform",
    "IBM Softlayer",
    "Microsoft Azure",
    "No Competition",
    "On-Prem",
    "Oracle Cloud",
    "Other- Cost Optimization",
]
CountryCodeType = Literal[
    "AD",
    "AE",
    "AF",
    "AG",
    "AI",
    "AL",
    "AM",
    "AN",
    "AO",
    "AQ",
    "AR",
    "AS",
    "AT",
    "AU",
    "AW",
    "AX",
    "AZ",
    "BA",
    "BB",
    "BD",
    "BE",
    "BF",
    "BG",
    "BH",
    "BI",
    "BJ",
    "BL",
    "BM",
    "BN",
    "BO",
    "BQ",
    "BR",
    "BS",
    "BT",
    "BV",
    "BW",
    "BY",
    "BZ",
    "CA",
    "CC",
    "CD",
    "CF",
    "CG",
    "CH",
    "CI",
    "CK",
    "CL",
    "CM",
    "CN",
    "CO",
    "CR",
    "CU",
    "CV",
    "CW",
    "CX",
    "CY",
    "CZ",
    "DE",
    "DJ",
    "DK",
    "DM",
    "DO",
    "DZ",
    "EC",
    "EE",
    "EG",
    "EH",
    "ER",
    "ES",
    "ET",
    "FI",
    "FJ",
    "FK",
    "FM",
    "FO",
    "FR",
    "GA",
    "GB",
    "GD",
    "GE",
    "GF",
    "GG",
    "GH",
    "GI",
    "GL",
    "GM",
    "GN",
    "GP",
    "GQ",
    "GR",
    "GS",
    "GT",
    "GU",
    "GW",
    "GY",
    "HK",
    "HM",
    "HN",
    "HR",
    "HT",
    "HU",
    "ID",
    "IE",
    "IL",
    "IM",
    "IN",
    "IO",
    "IQ",
    "IR",
    "IS",
    "IT",
    "JE",
    "JM",
    "JO",
    "JP",
    "KE",
    "KG",
    "KH",
    "KI",
    "KM",
    "KN",
    "KR",
    "KW",
    "KY",
    "KZ",
    "LA",
    "LB",
    "LC",
    "LI",
    "LK",
    "LR",
    "LS",
    "LT",
    "LU",
    "LV",
    "LY",
    "MA",
    "MC",
    "MD",
    "ME",
    "MF",
    "MG",
    "MH",
    "MK",
    "ML",
    "MM",
    "MN",
    "MO",
    "MP",
    "MQ",
    "MR",
    "MS",
    "MT",
    "MU",
    "MV",
    "MW",
    "MX",
    "MY",
    "MZ",
    "NA",
    "NC",
    "NE",
    "NF",
    "NG",
    "NI",
    "NL",
    "NO",
    "NP",
    "NR",
    "NU",
    "NZ",
    "OM",
    "PA",
    "PE",
    "PF",
    "PG",
    "PH",
    "PK",
    "PL",
    "PM",
    "PN",
    "PR",
    "PS",
    "PT",
    "PW",
    "PY",
    "QA",
    "RE",
    "RO",
    "RS",
    "RU",
    "RW",
    "SA",
    "SB",
    "SC",
    "SD",
    "SE",
    "SG",
    "SH",
    "SI",
    "SJ",
    "SK",
    "SL",
    "SM",
    "SN",
    "SO",
    "SR",
    "SS",
    "ST",
    "SV",
    "SX",
    "SY",
    "SZ",
    "TC",
    "TD",
    "TF",
    "TG",
    "TH",
    "TJ",
    "TK",
    "TL",
    "TM",
    "TN",
    "TO",
    "TR",
    "TT",
    "TV",
    "TW",
    "TZ",
    "UA",
    "UG",
    "UM",
    "US",
    "UY",
    "UZ",
    "VA",
    "VC",
    "VE",
    "VG",
    "VI",
    "VN",
    "VU",
    "WF",
    "WS",
    "YE",
    "YT",
    "ZA",
    "ZM",
    "ZW",
]
CurrencyCodeType = Literal[
    "AED",
    "AFN",
    "ALL",
    "AMD",
    "ANG",
    "AOA",
    "ARS",
    "AUD",
    "AWG",
    "AZN",
    "BAM",
    "BBD",
    "BDT",
    "BGN",
    "BHD",
    "BIF",
    "BMD",
    "BND",
    "BOB",
    "BOV",
    "BRL",
    "BSD",
    "BTN",
    "BWP",
    "BYN",
    "BZD",
    "CAD",
    "CDF",
    "CHE",
    "CHF",
    "CHW",
    "CLF",
    "CLP",
    "CNY",
    "COP",
    "COU",
    "CRC",
    "CUC",
    "CUP",
    "CVE",
    "CZK",
    "DJF",
    "DKK",
    "DOP",
    "DZD",
    "EGP",
    "ERN",
    "ETB",
    "EUR",
    "FJD",
    "FKP",
    "GBP",
    "GEL",
    "GHS",
    "GIP",
    "GMD",
    "GNF",
    "GTQ",
    "GYD",
    "HKD",
    "HNL",
    "HRK",
    "HTG",
    "HUF",
    "IDR",
    "ILS",
    "INR",
    "IQD",
    "IRR",
    "ISK",
    "JMD",
    "JOD",
    "JPY",
    "KES",
    "KGS",
    "KHR",
    "KMF",
    "KPW",
    "KRW",
    "KWD",
    "KYD",
    "KZT",
    "LAK",
    "LBP",
    "LKR",
    "LRD",
    "LSL",
    "LYD",
    "MAD",
    "MDL",
    "MGA",
    "MKD",
    "MMK",
    "MNT",
    "MOP",
    "MRU",
    "MUR",
    "MVR",
    "MWK",
    "MXN",
    "MXV",
    "MYR",
    "MZN",
    "NAD",
    "NGN",
    "NIO",
    "NOK",
    "NPR",
    "NZD",
    "OMR",
    "PAB",
    "PEN",
    "PGK",
    "PHP",
    "PKR",
    "PLN",
    "PYG",
    "QAR",
    "RON",
    "RSD",
    "RUB",
    "RWF",
    "SAR",
    "SBD",
    "SCR",
    "SDG",
    "SEK",
    "SGD",
    "SHP",
    "SLL",
    "SOS",
    "SRD",
    "SSP",
    "STN",
    "SVC",
    "SYP",
    "SZL",
    "THB",
    "TJS",
    "TMT",
    "TND",
    "TOP",
    "TRY",
    "TTD",
    "TWD",
    "TZS",
    "UAH",
    "UGX",
    "USD",
    "USN",
    "UYI",
    "UYU",
    "UZS",
    "VEF",
    "VND",
    "VUV",
    "WST",
    "XAF",
    "XCD",
    "XDR",
    "XOF",
    "XPF",
    "XSU",
    "XUA",
    "YER",
    "ZAR",
    "ZMW",
    "ZWL",
]
DeliveryModelType = Literal[
    "BYOL or AMI", "Managed Services", "Other", "Professional Services", "Resell", "SaaS or PaaS"
]
EngagementContextTypeType = Literal["CustomerProject"]
EngagementInvitationPayloadTypeType = Literal["OpportunityInvitation"]
EngagementScoreType = Literal["High", "Low", "Medium"]
EngagementSortNameType = Literal["CreatedDate"]
ExpectedCustomerSpendCurrencyCodeEnumType = Literal[
    "AED",
    "AFN",
    "ALL",
    "AMD",
    "ANG",
    "AOA",
    "ARS",
    "AUD",
    "AWG",
    "AZN",
    "BAM",
    "BBD",
    "BDT",
    "BGN",
    "BHD",
    "BIF",
    "BMD",
    "BND",
    "BOB",
    "BOV",
    "BRL",
    "BSD",
    "BTN",
    "BWP",
    "BYN",
    "BZD",
    "CAD",
    "CDF",
    "CHE",
    "CHF",
    "CHW",
    "CLF",
    "CLP",
    "CNY",
    "COP",
    "COU",
    "CRC",
    "CUC",
    "CUP",
    "CVE",
    "CZK",
    "DJF",
    "DKK",
    "DOP",
    "DZD",
    "EGP",
    "ERN",
    "ETB",
    "EUR",
    "FJD",
    "FKP",
    "GBP",
    "GEL",
    "GHS",
    "GIP",
    "GMD",
    "GNF",
    "GTQ",
    "GYD",
    "HKD",
    "HNL",
    "HRK",
    "HTG",
    "HUF",
    "IDR",
    "ILS",
    "INR",
    "IQD",
    "IRR",
    "ISK",
    "JMD",
    "JOD",
    "JPY",
    "KES",
    "KGS",
    "KHR",
    "KMF",
    "KPW",
    "KRW",
    "KWD",
    "KYD",
    "KZT",
    "LAK",
    "LBP",
    "LKR",
    "LRD",
    "LSL",
    "LYD",
    "MAD",
    "MDL",
    "MGA",
    "MKD",
    "MMK",
    "MNT",
    "MOP",
    "MRU",
    "MUR",
    "MVR",
    "MWK",
    "MXN",
    "MXV",
    "MYR",
    "MZN",
    "NAD",
    "NGN",
    "NIO",
    "NOK",
    "NPR",
    "NZD",
    "OMR",
    "PAB",
    "PEN",
    "PGK",
    "PHP",
    "PKR",
    "PLN",
    "PYG",
    "QAR",
    "RON",
    "RSD",
    "RUB",
    "RWF",
    "SAR",
    "SBD",
    "SCR",
    "SDG",
    "SEK",
    "SGD",
    "SHP",
    "SLL",
    "SOS",
    "SRD",
    "SSP",
    "STN",
    "SVC",
    "SYP",
    "SZL",
    "THB",
    "TJS",
    "TMT",
    "TND",
    "TOP",
    "TRY",
    "TTD",
    "TWD",
    "TZS",
    "UAH",
    "UGX",
    "USD",
    "USN",
    "UYI",
    "UYU",
    "UZS",
    "VEF",
    "VND",
    "VUV",
    "WST",
    "XAF",
    "XCD",
    "XDR",
    "XOF",
    "XPF",
    "XSU",
    "XUA",
    "YER",
    "ZAR",
    "ZMW",
    "ZWL",
]
IndustryType = Literal[
    "Aerospace",
    "Agriculture",
    "Automotive",
    "Computers and Electronics",
    "Consumer Goods",
    "Education",
    "Energy - Oil and Gas",
    "Energy - Power and Utilities",
    "Financial Services",
    "Gaming",
    "Government",
    "Healthcare",
    "Hospitality",
    "Life Sciences",
    "Manufacturing",
    "Marketing and Advertising",
    "Media and Entertainment",
    "Mining",
    "Non-Profit Organization",
    "Other",
    "Professional Services",
    "Real Estate and Construction",
    "Retail",
    "Software and Internet",
    "Telecommunications",
    "Transportation and Logistics",
    "Travel",
    "Wholesale and Distribution",
]
InvitationStatusType = Literal["ACCEPTED", "EXPIRED", "PENDING", "REJECTED"]
InvolvementTypeChangeReasonType = Literal[
    "Change in Deal Information",
    "Customer Requested",
    "Expansion Opportunity",
    "Risk Mitigation",
    "Technical Complexity",
]
ListEngagementByAcceptingInvitationTasksPaginatorName = Literal[
    "list_engagement_by_accepting_invitation_tasks"
]
ListEngagementFromOpportunityTasksPaginatorName = Literal["list_engagement_from_opportunity_tasks"]
ListEngagementInvitationsPaginatorName = Literal["list_engagement_invitations"]
ListEngagementMembersPaginatorName = Literal["list_engagement_members"]
ListEngagementResourceAssociationsPaginatorName = Literal["list_engagement_resource_associations"]
ListEngagementsPaginatorName = Literal["list_engagements"]
ListOpportunitiesPaginatorName = Literal["list_opportunities"]
ListResourceSnapshotJobsPaginatorName = Literal["list_resource_snapshot_jobs"]
ListResourceSnapshotsPaginatorName = Literal["list_resource_snapshots"]
ListSolutionsPaginatorName = Literal["list_solutions"]
ListTasksSortNameType = Literal["StartTime"]
MarketingSourceType = Literal["Marketing Activity", "None"]
NationalSecurityType = Literal["No", "Yes"]
OpportunityEngagementInvitationSortNameType = Literal["InvitationDate"]
OpportunityOriginType = Literal["AWS Referral", "Partner Referral"]
OpportunitySortNameType = Literal["CustomerCompanyName", "Identifier", "LastModifiedDate"]
OpportunityTypeType = Literal["Expansion", "Flat Renewal", "Net New Business"]
ParticipantTypeType = Literal["RECEIVER", "SENDER"]
PaymentFrequencyType = Literal["Monthly"]
PrimaryNeedFromAwsType = Literal[
    "Co-Sell - Architectural Validation",
    "Co-Sell - Business Presentation",
    "Co-Sell - Competitive Information",
    "Co-Sell - Deal Support",
    "Co-Sell - Pricing Assistance",
    "Co-Sell - Support for Public Tender / RFx",
    "Co-Sell - Technical Consultation",
    "Co-Sell - Total Cost of Ownership Evaluation",
]
ReasonCodeType = Literal[
    "EngagementAccessDenied",
    "EngagementConflict",
    "EngagementInvitationConflict",
    "EngagementValidationFailed",
    "InternalError",
    "InvitationAccessDenied",
    "InvitationValidationFailed",
    "OpportunityAccessDenied",
    "OpportunityConflict",
    "OpportunitySubmissionFailed",
    "OpportunityValidationFailed",
    "RequestThrottled",
    "ResourceSnapshotAccessDenied",
    "ResourceSnapshotConflict",
    "ResourceSnapshotJobAccessDenied",
    "ResourceSnapshotJobConflict",
    "ResourceSnapshotJobValidationFailed",
    "ResourceSnapshotValidationFailed",
    "ServiceQuotaExceeded",
]
ReceiverResponsibilityType = Literal[
    "Co-Sell Facilitator",
    "Distributor",
    "Facilitator",
    "Hardware Partner",
    "Managed Service Provider",
    "Reseller",
    "Services Partner",
    "Software Partner",
    "Training Partner",
]
RelatedEntityTypeType = Literal["AwsMarketplaceOffers", "AwsProducts", "Solutions"]
ResourceSnapshotJobStatusType = Literal["Running", "Stopped"]
ResourceTypeType = Literal["Opportunity"]
RevenueModelType = Literal["Contract", "Pay-as-you-go", "Subscription"]
ReviewStatusType = Literal[
    "Action Required", "Approved", "In review", "Pending Submission", "Rejected", "Submitted"
]
SalesActivityType = Literal[
    "Agreed on solution to Business Problem",
    "Completed Action Plan",
    "Conducted POC / Demo",
    "Customer has shown interest in solution",
    "Finalized Deployment Need",
    "In evaluation / planning stage",
    "Initialized discussions with customer",
    "SOW Signed",
]
SalesInvolvementTypeType = Literal["Co-Sell", "For Visibility Only"]
SolutionSortNameType = Literal["Category", "CreatedDate", "Identifier", "Name", "Status"]
SolutionStatusType = Literal["Active", "Draft", "Inactive"]
SortByType = Literal["CreatedDate"]
SortOrderType = Literal["ASCENDING", "DESCENDING"]
StageType = Literal[
    "Business Validation",
    "Closed Lost",
    "Committed",
    "Launched",
    "Prospect",
    "Qualified",
    "Technical Validation",
]
TaskStatusType = Literal["COMPLETE", "FAILED", "IN_PROGRESS"]
VisibilityType = Literal["Full", "Limited"]
PartnerCentralSellingAPIServiceName = Literal["partnercentral-selling"]
ServiceName = Literal[
    "accessanalyzer",
    "account",
    "acm",
    "acm-pca",
    "amp",
    "amplify",
    "amplifybackend",
    "amplifyuibuilder",
    "apigateway",
    "apigatewaymanagementapi",
    "apigatewayv2",
    "appconfig",
    "appconfigdata",
    "appfabric",
    "appflow",
    "appintegrations",
    "application-autoscaling",
    "application-insights",
    "application-signals",
    "applicationcostprofiler",
    "appmesh",
    "apprunner",
    "appstream",
    "appsync",
    "apptest",
    "arc-zonal-shift",
    "artifact",
    "athena",
    "auditmanager",
    "autoscaling",
    "autoscaling-plans",
    "b2bi",
    "backup",
    "backup-gateway",
    "backupsearch",
    "batch",
    "bcm-data-exports",
    "bcm-pricing-calculator",
    "bedrock",
    "bedrock-agent",
    "bedrock-agent-runtime",
    "bedrock-data-automation",
    "bedrock-data-automation-runtime",
    "bedrock-runtime",
    "billing",
    "billingconductor",
    "braket",
    "budgets",
    "ce",
    "chatbot",
    "chime",
    "chime-sdk-identity",
    "chime-sdk-media-pipelines",
    "chime-sdk-meetings",
    "chime-sdk-messaging",
    "chime-sdk-voice",
    "cleanrooms",
    "cleanroomsml",
    "cloud9",
    "cloudcontrol",
    "clouddirectory",
    "cloudformation",
    "cloudfront",
    "cloudfront-keyvaluestore",
    "cloudhsm",
    "cloudhsmv2",
    "cloudsearch",
    "cloudsearchdomain",
    "cloudtrail",
    "cloudtrail-data",
    "cloudwatch",
    "codeartifact",
    "codebuild",
    "codecatalyst",
    "codecommit",
    "codeconnections",
    "codedeploy",
    "codeguru-reviewer",
    "codeguru-security",
    "codeguruprofiler",
    "codepipeline",
    "codestar-connections",
    "codestar-notifications",
    "cognito-identity",
    "cognito-idp",
    "cognito-sync",
    "comprehend",
    "comprehendmedical",
    "compute-optimizer",
    "config",
    "connect",
    "connect-contact-lens",
    "connectcampaigns",
    "connectcampaignsv2",
    "connectcases",
    "connectparticipant",
    "controlcatalog",
    "controltower",
    "cost-optimization-hub",
    "cur",
    "customer-profiles",
    "databrew",
    "dataexchange",
    "datapipeline",
    "datasync",
    "datazone",
    "dax",
    "deadline",
    "detective",
    "devicefarm",
    "devops-guru",
    "directconnect",
    "discovery",
    "dlm",
    "dms",
    "docdb",
    "docdb-elastic",
    "drs",
    "ds",
    "ds-data",
    "dsql",
    "dynamodb",
    "dynamodbstreams",
    "ebs",
    "ec2",
    "ec2-instance-connect",
    "ecr",
    "ecr-public",
    "ecs",
    "efs",
    "eks",
    "eks-auth",
    "elasticache",
    "elasticbeanstalk",
    "elastictranscoder",
    "elb",
    "elbv2",
    "emr",
    "emr-containers",
    "emr-serverless",
    "entityresolution",
    "es",
    "events",
    "evidently",
    "finspace",
    "finspace-data",
    "firehose",
    "fis",
    "fms",
    "forecast",
    "forecastquery",
    "frauddetector",
    "freetier",
    "fsx",
    "gamelift",
    "geo-maps",
    "geo-places",
    "geo-routes",
    "glacier",
    "globalaccelerator",
    "glue",
    "grafana",
    "greengrass",
    "greengrassv2",
    "groundstation",
    "guardduty",
    "health",
    "healthlake",
    "iam",
    "identitystore",
    "imagebuilder",
    "importexport",
    "inspector",
    "inspector-scan",
    "inspector2",
    "internetmonitor",
    "invoicing",
    "iot",
    "iot-data",
    "iot-jobs-data",
    "iotanalytics",
    "iotdeviceadvisor",
    "iotevents",
    "iotevents-data",
    "iotfleethub",
    "iotfleetwise",
    "iotsecuretunneling",
    "iotsitewise",
    "iotthingsgraph",
    "iottwinmaker",
    "iotwireless",
    "ivs",
    "ivs-realtime",
    "ivschat",
    "kafka",
    "kafkaconnect",
    "kendra",
    "kendra-ranking",
    "keyspaces",
    "kinesis",
    "kinesis-video-archived-media",
    "kinesis-video-media",
    "kinesis-video-signaling",
    "kinesis-video-webrtc-storage",
    "kinesisanalytics",
    "kinesisanalyticsv2",
    "kinesisvideo",
    "kms",
    "lakeformation",
    "lambda",
    "launch-wizard",
    "lex-models",
    "lex-runtime",
    "lexv2-models",
    "lexv2-runtime",
    "license-manager",
    "license-manager-linux-subscriptions",
    "license-manager-user-subscriptions",
    "lightsail",
    "location",
    "logs",
    "lookoutequipment",
    "lookoutmetrics",
    "lookoutvision",
    "m2",
    "machinelearning",
    "macie2",
    "mailmanager",
    "managedblockchain",
    "managedblockchain-query",
    "marketplace-agreement",
    "marketplace-catalog",
    "marketplace-deployment",
    "marketplace-entitlement",
    "marketplace-reporting",
    "marketplacecommerceanalytics",
    "mediaconnect",
    "mediaconvert",
    "medialive",
    "mediapackage",
    "mediapackage-vod",
    "mediapackagev2",
    "mediastore",
    "mediastore-data",
    "mediatailor",
    "medical-imaging",
    "memorydb",
    "meteringmarketplace",
    "mgh",
    "mgn",
    "migration-hub-refactor-spaces",
    "migrationhub-config",
    "migrationhuborchestrator",
    "migrationhubstrategy",
    "mq",
    "mturk",
    "mwaa",
    "neptune",
    "neptune-graph",
    "neptunedata",
    "network-firewall",
    "networkflowmonitor",
    "networkmanager",
    "networkmonitor",
    "notifications",
    "notificationscontacts",
    "oam",
    "observabilityadmin",
    "omics",
    "opensearch",
    "opensearchserverless",
    "opsworks",
    "opsworkscm",
    "organizations",
    "osis",
    "outposts",
    "panorama",
    "partnercentral-selling",
    "payment-cryptography",
    "payment-cryptography-data",
    "pca-connector-ad",
    "pca-connector-scep",
    "pcs",
    "personalize",
    "personalize-events",
    "personalize-runtime",
    "pi",
    "pinpoint",
    "pinpoint-email",
    "pinpoint-sms-voice",
    "pinpoint-sms-voice-v2",
    "pipes",
    "polly",
    "pricing",
    "privatenetworks",
    "proton",
    "qapps",
    "qbusiness",
    "qconnect",
    "qldb",
    "qldb-session",
    "quicksight",
    "ram",
    "rbin",
    "rds",
    "rds-data",
    "redshift",
    "redshift-data",
    "redshift-serverless",
    "rekognition",
    "repostspace",
    "resiliencehub",
    "resource-explorer-2",
    "resource-groups",
    "resourcegroupstaggingapi",
    "robomaker",
    "rolesanywhere",
    "route53",
    "route53-recovery-cluster",
    "route53-recovery-control-config",
    "route53-recovery-readiness",
    "route53domains",
    "route53profiles",
    "route53resolver",
    "rum",
    "s3",
    "s3control",
    "s3outposts",
    "s3tables",
    "sagemaker",
    "sagemaker-a2i-runtime",
    "sagemaker-edge",
    "sagemaker-featurestore-runtime",
    "sagemaker-geospatial",
    "sagemaker-metrics",
    "sagemaker-runtime",
    "savingsplans",
    "scheduler",
    "schemas",
    "sdb",
    "secretsmanager",
    "security-ir",
    "securityhub",
    "securitylake",
    "serverlessrepo",
    "service-quotas",
    "servicecatalog",
    "servicecatalog-appregistry",
    "servicediscovery",
    "ses",
    "sesv2",
    "shield",
    "signer",
    "simspaceweaver",
    "sms",
    "sms-voice",
    "snow-device-management",
    "snowball",
    "sns",
    "socialmessaging",
    "sqs",
    "ssm",
    "ssm-contacts",
    "ssm-incidents",
    "ssm-quicksetup",
    "ssm-sap",
    "sso",
    "sso-admin",
    "sso-oidc",
    "stepfunctions",
    "storagegateway",
    "sts",
    "supplychain",
    "support",
    "support-app",
    "swf",
    "synthetics",
    "taxsettings",
    "textract",
    "timestream-influxdb",
    "timestream-query",
    "timestream-write",
    "tnb",
    "transcribe",
    "transfer",
    "translate",
    "trustedadvisor",
    "verifiedpermissions",
    "voice-id",
    "vpc-lattice",
    "waf",
    "waf-regional",
    "wafv2",
    "wellarchitected",
    "wisdom",
    "workdocs",
    "workmail",
    "workmailmessageflow",
    "workspaces",
    "workspaces-thin-client",
    "workspaces-web",
    "xray",
]
ResourceServiceName = Literal[
    "cloudformation",
    "cloudwatch",
    "dynamodb",
    "ec2",
    "glacier",
    "iam",
    "opsworks",
    "s3",
    "sns",
    "sqs",
]
PaginatorName = Literal[
    "list_engagement_by_accepting_invitation_tasks",
    "list_engagement_from_opportunity_tasks",
    "list_engagement_invitations",
    "list_engagement_members",
    "list_engagement_resource_associations",
    "list_engagements",
    "list_opportunities",
    "list_resource_snapshot_jobs",
    "list_resource_snapshots",
    "list_solutions",
]
