"""
Type annotations for qbusiness service literal definitions.

[Documentation](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_qbusiness/literals/)

Copyright 2025 Vlad Emelianov

Usage::

    ```python
    from mypy_boto3_qbusiness.literals import APISchemaTypeType

    data: APISchemaTypeType = "OPEN_API_V3"
    ```
"""

import sys

if sys.version_info >= (3, 12):
    from typing import Literal
else:
    from typing_extensions import Literal


__all__ = (
    "APISchemaTypeType",
    "ActionPayloadFieldTypeType",
    "ApplicationStatusType",
    "AttachmentStatusType",
    "AttachmentsControlModeType",
    "AttributeTypeType",
    "AttributeValueOperatorType",
    "AutoSubscriptionStatusType",
    "BrowserExtensionType",
    "ChatModeType",
    "ContentTypeType",
    "CreatorModeControlType",
    "DataSourceStatusType",
    "DataSourceSyncJobStatusType",
    "DocumentAttributeBoostingLevelType",
    "DocumentContentOperatorType",
    "DocumentEnrichmentConditionOperatorType",
    "DocumentStatusType",
    "ErrorCodeType",
    "GetChatControlsConfigurationPaginatorName",
    "GroupStatusType",
    "IdentityTypeType",
    "ImageExtractionStatusType",
    "IndexStatusType",
    "IndexTypeType",
    "ListApplicationsPaginatorName",
    "ListAttachmentsPaginatorName",
    "ListConversationsPaginatorName",
    "ListDataAccessorsPaginatorName",
    "ListDataSourceSyncJobsPaginatorName",
    "ListDataSourcesPaginatorName",
    "ListDocumentsPaginatorName",
    "ListGroupsPaginatorName",
    "ListIndicesPaginatorName",
    "ListMessagesPaginatorName",
    "ListPluginActionsPaginatorName",
    "ListPluginTypeActionsPaginatorName",
    "ListPluginTypeMetadataPaginatorName",
    "ListPluginsPaginatorName",
    "ListRetrieversPaginatorName",
    "ListSubscriptionsPaginatorName",
    "ListWebExperiencesPaginatorName",
    "MemberRelationType",
    "MembershipTypeType",
    "MessageTypeType",
    "MessageUsefulnessReasonType",
    "MessageUsefulnessType",
    "NumberAttributeBoostingTypeType",
    "OrchestrationControlType",
    "PaginatorName",
    "PersonalizationControlModeType",
    "PluginBuildStatusType",
    "PluginStateType",
    "PluginTypeCategoryType",
    "PluginTypeType",
    "QAppsControlModeType",
    "QBusinessServiceName",
    "ReadAccessTypeType",
    "RegionName",
    "ResourceServiceName",
    "ResponseScopeType",
    "RetrieverStatusType",
    "RetrieverTypeType",
    "RuleTypeType",
    "ScoreConfidenceType",
    "SearchRelevantContentPaginatorName",
    "ServiceName",
    "StatusType",
    "StringAttributeValueBoostingLevelType",
    "SubscriptionTypeType",
    "WebExperienceSamplePromptsControlModeType",
    "WebExperienceStatusType",
)


APISchemaTypeType = Literal["OPEN_API_V3"]
ActionPayloadFieldTypeType = Literal["ARRAY", "BOOLEAN", "NUMBER", "STRING"]
ApplicationStatusType = Literal["ACTIVE", "CREATING", "DELETING", "FAILED", "UPDATING"]
AttachmentStatusType = Literal["FAILED", "SUCCESS"]
AttachmentsControlModeType = Literal["DISABLED", "ENABLED"]
AttributeTypeType = Literal["DATE", "NUMBER", "STRING", "STRING_LIST"]
AttributeValueOperatorType = Literal["DELETE"]
AutoSubscriptionStatusType = Literal["DISABLED", "ENABLED"]
BrowserExtensionType = Literal["CHROME", "FIREFOX"]
ChatModeType = Literal["CREATOR_MODE", "PLUGIN_MODE", "RETRIEVAL_MODE"]
ContentTypeType = Literal[
    "CSV",
    "HTML",
    "JSON",
    "MD",
    "MS_EXCEL",
    "MS_WORD",
    "PDF",
    "PLAIN_TEXT",
    "PPT",
    "RTF",
    "XML",
    "XSLT",
]
CreatorModeControlType = Literal["DISABLED", "ENABLED"]
DataSourceStatusType = Literal[
    "ACTIVE", "CREATING", "DELETING", "FAILED", "PENDING_CREATION", "UPDATING"
]
DataSourceSyncJobStatusType = Literal[
    "ABORTED", "FAILED", "INCOMPLETE", "STOPPING", "SUCCEEDED", "SYNCING", "SYNCING_INDEXING"
]
DocumentAttributeBoostingLevelType = Literal["HIGH", "LOW", "MEDIUM", "NONE", "VERY_HIGH"]
DocumentContentOperatorType = Literal["DELETE"]
DocumentEnrichmentConditionOperatorType = Literal[
    "BEGINS_WITH",
    "CONTAINS",
    "EQUALS",
    "EXISTS",
    "GREATER_THAN",
    "GREATER_THAN_OR_EQUALS",
    "LESS_THAN",
    "LESS_THAN_OR_EQUALS",
    "NOT_CONTAINS",
    "NOT_EQUALS",
    "NOT_EXISTS",
]
DocumentStatusType = Literal[
    "DELETED",
    "DELETING",
    "DOCUMENT_FAILED_TO_INDEX",
    "FAILED",
    "INDEXED",
    "PROCESSING",
    "RECEIVED",
    "UPDATED",
]
ErrorCodeType = Literal["InternalError", "InvalidRequest", "ResourceInactive", "ResourceNotFound"]
GetChatControlsConfigurationPaginatorName = Literal["get_chat_controls_configuration"]
GroupStatusType = Literal["DELETED", "DELETING", "FAILED", "PROCESSING", "SUCCEEDED"]
IdentityTypeType = Literal[
    "AWS_IAM_IDC", "AWS_IAM_IDP_OIDC", "AWS_IAM_IDP_SAML", "AWS_QUICKSIGHT_IDP"
]
ImageExtractionStatusType = Literal["DISABLED", "ENABLED"]
IndexStatusType = Literal["ACTIVE", "CREATING", "DELETING", "FAILED", "UPDATING"]
IndexTypeType = Literal["ENTERPRISE", "STARTER"]
ListApplicationsPaginatorName = Literal["list_applications"]
ListAttachmentsPaginatorName = Literal["list_attachments"]
ListConversationsPaginatorName = Literal["list_conversations"]
ListDataAccessorsPaginatorName = Literal["list_data_accessors"]
ListDataSourceSyncJobsPaginatorName = Literal["list_data_source_sync_jobs"]
ListDataSourcesPaginatorName = Literal["list_data_sources"]
ListDocumentsPaginatorName = Literal["list_documents"]
ListGroupsPaginatorName = Literal["list_groups"]
ListIndicesPaginatorName = Literal["list_indices"]
ListMessagesPaginatorName = Literal["list_messages"]
ListPluginActionsPaginatorName = Literal["list_plugin_actions"]
ListPluginTypeActionsPaginatorName = Literal["list_plugin_type_actions"]
ListPluginTypeMetadataPaginatorName = Literal["list_plugin_type_metadata"]
ListPluginsPaginatorName = Literal["list_plugins"]
ListRetrieversPaginatorName = Literal["list_retrievers"]
ListSubscriptionsPaginatorName = Literal["list_subscriptions"]
ListWebExperiencesPaginatorName = Literal["list_web_experiences"]
MemberRelationType = Literal["AND", "OR"]
MembershipTypeType = Literal["DATASOURCE", "INDEX"]
MessageTypeType = Literal["SYSTEM", "USER"]
MessageUsefulnessReasonType = Literal[
    "COMPLETE",
    "FACTUALLY_CORRECT",
    "HARMFUL_OR_UNSAFE",
    "HELPFUL",
    "INCORRECT_OR_MISSING_SOURCES",
    "NOT_BASED_ON_DOCUMENTS",
    "NOT_COMPLETE",
    "NOT_CONCISE",
    "NOT_FACTUALLY_CORRECT",
    "NOT_HELPFUL",
    "OTHER",
    "RELEVANT_SOURCES",
]
MessageUsefulnessType = Literal["NOT_USEFUL", "USEFUL"]
NumberAttributeBoostingTypeType = Literal["PRIORITIZE_LARGER_VALUES", "PRIORITIZE_SMALLER_VALUES"]
OrchestrationControlType = Literal["DISABLED", "ENABLED"]
PersonalizationControlModeType = Literal["DISABLED", "ENABLED"]
PluginBuildStatusType = Literal[
    "CREATE_FAILED",
    "CREATE_IN_PROGRESS",
    "DELETE_FAILED",
    "DELETE_IN_PROGRESS",
    "READY",
    "UPDATE_FAILED",
    "UPDATE_IN_PROGRESS",
]
PluginStateType = Literal["DISABLED", "ENABLED"]
PluginTypeCategoryType = Literal[
    "Communication",
    "Customer relationship management (CRM)",
    "Productivity",
    "Project management",
    "Ticketing and incident management",
]
PluginTypeType = Literal[
    "ASANA",
    "ATLASSIAN_CONFLUENCE",
    "CUSTOM",
    "GOOGLE_CALENDAR",
    "JIRA",
    "JIRA_CLOUD",
    "MICROSOFT_EXCHANGE",
    "MICROSOFT_TEAMS",
    "PAGERDUTY_ADVANCE",
    "QUICKSIGHT",
    "SALESFORCE",
    "SALESFORCE_CRM",
    "SERVICENOW_NOW_PLATFORM",
    "SERVICE_NOW",
    "SMARTSHEET",
    "ZENDESK",
    "ZENDESK_SUITE",
]
QAppsControlModeType = Literal["DISABLED", "ENABLED"]
ReadAccessTypeType = Literal["ALLOW", "DENY"]
ResponseScopeType = Literal["ENTERPRISE_CONTENT_ONLY", "EXTENDED_KNOWLEDGE_ENABLED"]
RetrieverStatusType = Literal["ACTIVE", "CREATING", "FAILED"]
RetrieverTypeType = Literal["KENDRA_INDEX", "NATIVE_INDEX"]
RuleTypeType = Literal["CONTENT_BLOCKER_RULE", "CONTENT_RETRIEVAL_RULE"]
ScoreConfidenceType = Literal["HIGH", "LOW", "MEDIUM", "NOT_AVAILABLE", "VERY_HIGH"]
SearchRelevantContentPaginatorName = Literal["search_relevant_content"]
StatusType = Literal["DISABLED", "ENABLED"]
StringAttributeValueBoostingLevelType = Literal["HIGH", "LOW", "MEDIUM", "VERY_HIGH"]
SubscriptionTypeType = Literal["Q_BUSINESS", "Q_LITE"]
WebExperienceSamplePromptsControlModeType = Literal["DISABLED", "ENABLED"]
WebExperienceStatusType = Literal["ACTIVE", "CREATING", "DELETING", "FAILED", "PENDING_AUTH_CONFIG"]
QBusinessServiceName = Literal["qbusiness"]
ServiceName = Literal[
    "accessanalyzer",
    "account",
    "acm",
    "acm-pca",
    "amp",
    "amplify",
    "amplifybackend",
    "amplifyuibuilder",
    "apigateway",
    "apigatewaymanagementapi",
    "apigatewayv2",
    "appconfig",
    "appconfigdata",
    "appfabric",
    "appflow",
    "appintegrations",
    "application-autoscaling",
    "application-insights",
    "application-signals",
    "applicationcostprofiler",
    "appmesh",
    "apprunner",
    "appstream",
    "appsync",
    "apptest",
    "arc-zonal-shift",
    "artifact",
    "athena",
    "auditmanager",
    "autoscaling",
    "autoscaling-plans",
    "b2bi",
    "backup",
    "backup-gateway",
    "backupsearch",
    "batch",
    "bcm-data-exports",
    "bcm-pricing-calculator",
    "bedrock",
    "bedrock-agent",
    "bedrock-agent-runtime",
    "bedrock-data-automation",
    "bedrock-data-automation-runtime",
    "bedrock-runtime",
    "billing",
    "billingconductor",
    "braket",
    "budgets",
    "ce",
    "chatbot",
    "chime",
    "chime-sdk-identity",
    "chime-sdk-media-pipelines",
    "chime-sdk-meetings",
    "chime-sdk-messaging",
    "chime-sdk-voice",
    "cleanrooms",
    "cleanroomsml",
    "cloud9",
    "cloudcontrol",
    "clouddirectory",
    "cloudformation",
    "cloudfront",
    "cloudfront-keyvaluestore",
    "cloudhsm",
    "cloudhsmv2",
    "cloudsearch",
    "cloudsearchdomain",
    "cloudtrail",
    "cloudtrail-data",
    "cloudwatch",
    "codeartifact",
    "codebuild",
    "codecatalyst",
    "codecommit",
    "codeconnections",
    "codedeploy",
    "codeguru-reviewer",
    "codeguru-security",
    "codeguruprofiler",
    "codepipeline",
    "codestar-connections",
    "codestar-notifications",
    "cognito-identity",
    "cognito-idp",
    "cognito-sync",
    "comprehend",
    "comprehendmedical",
    "compute-optimizer",
    "config",
    "connect",
    "connect-contact-lens",
    "connectcampaigns",
    "connectcampaignsv2",
    "connectcases",
    "connectparticipant",
    "controlcatalog",
    "controltower",
    "cost-optimization-hub",
    "cur",
    "customer-profiles",
    "databrew",
    "dataexchange",
    "datapipeline",
    "datasync",
    "datazone",
    "dax",
    "deadline",
    "detective",
    "devicefarm",
    "devops-guru",
    "directconnect",
    "discovery",
    "dlm",
    "dms",
    "docdb",
    "docdb-elastic",
    "drs",
    "ds",
    "ds-data",
    "dsql",
    "dynamodb",
    "dynamodbstreams",
    "ebs",
    "ec2",
    "ec2-instance-connect",
    "ecr",
    "ecr-public",
    "ecs",
    "efs",
    "eks",
    "eks-auth",
    "elasticache",
    "elasticbeanstalk",
    "elastictranscoder",
    "elb",
    "elbv2",
    "emr",
    "emr-containers",
    "emr-serverless",
    "entityresolution",
    "es",
    "events",
    "evidently",
    "finspace",
    "finspace-data",
    "firehose",
    "fis",
    "fms",
    "forecast",
    "forecastquery",
    "frauddetector",
    "freetier",
    "fsx",
    "gamelift",
    "geo-maps",
    "geo-places",
    "geo-routes",
    "glacier",
    "globalaccelerator",
    "glue",
    "grafana",
    "greengrass",
    "greengrassv2",
    "groundstation",
    "guardduty",
    "health",
    "healthlake",
    "iam",
    "identitystore",
    "imagebuilder",
    "importexport",
    "inspector",
    "inspector-scan",
    "inspector2",
    "internetmonitor",
    "invoicing",
    "iot",
    "iot-data",
    "iot-jobs-data",
    "iotanalytics",
    "iotdeviceadvisor",
    "iotevents",
    "iotevents-data",
    "iotfleethub",
    "iotfleetwise",
    "iotsecuretunneling",
    "iotsitewise",
    "iotthingsgraph",
    "iottwinmaker",
    "iotwireless",
    "ivs",
    "ivs-realtime",
    "ivschat",
    "kafka",
    "kafkaconnect",
    "kendra",
    "kendra-ranking",
    "keyspaces",
    "kinesis",
    "kinesis-video-archived-media",
    "kinesis-video-media",
    "kinesis-video-signaling",
    "kinesis-video-webrtc-storage",
    "kinesisanalytics",
    "kinesisanalyticsv2",
    "kinesisvideo",
    "kms",
    "lakeformation",
    "lambda",
    "launch-wizard",
    "lex-models",
    "lex-runtime",
    "lexv2-models",
    "lexv2-runtime",
    "license-manager",
    "license-manager-linux-subscriptions",
    "license-manager-user-subscriptions",
    "lightsail",
    "location",
    "logs",
    "lookoutequipment",
    "lookoutmetrics",
    "lookoutvision",
    "m2",
    "machinelearning",
    "macie2",
    "mailmanager",
    "managedblockchain",
    "managedblockchain-query",
    "marketplace-agreement",
    "marketplace-catalog",
    "marketplace-deployment",
    "marketplace-entitlement",
    "marketplace-reporting",
    "marketplacecommerceanalytics",
    "mediaconnect",
    "mediaconvert",
    "medialive",
    "mediapackage",
    "mediapackage-vod",
    "mediapackagev2",
    "mediastore",
    "mediastore-data",
    "mediatailor",
    "medical-imaging",
    "memorydb",
    "meteringmarketplace",
    "mgh",
    "mgn",
    "migration-hub-refactor-spaces",
    "migrationhub-config",
    "migrationhuborchestrator",
    "migrationhubstrategy",
    "mq",
    "mturk",
    "mwaa",
    "neptune",
    "neptune-graph",
    "neptunedata",
    "network-firewall",
    "networkflowmonitor",
    "networkmanager",
    "networkmonitor",
    "notifications",
    "notificationscontacts",
    "oam",
    "observabilityadmin",
    "omics",
    "opensearch",
    "opensearchserverless",
    "opsworks",
    "opsworkscm",
    "organizations",
    "osis",
    "outposts",
    "panorama",
    "partnercentral-selling",
    "payment-cryptography",
    "payment-cryptography-data",
    "pca-connector-ad",
    "pca-connector-scep",
    "pcs",
    "personalize",
    "personalize-events",
    "personalize-runtime",
    "pi",
    "pinpoint",
    "pinpoint-email",
    "pinpoint-sms-voice",
    "pinpoint-sms-voice-v2",
    "pipes",
    "polly",
    "pricing",
    "privatenetworks",
    "proton",
    "qapps",
    "qbusiness",
    "qconnect",
    "qldb",
    "qldb-session",
    "quicksight",
    "ram",
    "rbin",
    "rds",
    "rds-data",
    "redshift",
    "redshift-data",
    "redshift-serverless",
    "rekognition",
    "repostspace",
    "resiliencehub",
    "resource-explorer-2",
    "resource-groups",
    "resourcegroupstaggingapi",
    "robomaker",
    "rolesanywhere",
    "route53",
    "route53-recovery-cluster",
    "route53-recovery-control-config",
    "route53-recovery-readiness",
    "route53domains",
    "route53profiles",
    "route53resolver",
    "rum",
    "s3",
    "s3control",
    "s3outposts",
    "s3tables",
    "sagemaker",
    "sagemaker-a2i-runtime",
    "sagemaker-edge",
    "sagemaker-featurestore-runtime",
    "sagemaker-geospatial",
    "sagemaker-metrics",
    "sagemaker-runtime",
    "savingsplans",
    "scheduler",
    "schemas",
    "sdb",
    "secretsmanager",
    "security-ir",
    "securityhub",
    "securitylake",
    "serverlessrepo",
    "service-quotas",
    "servicecatalog",
    "servicecatalog-appregistry",
    "servicediscovery",
    "ses",
    "sesv2",
    "shield",
    "signer",
    "simspaceweaver",
    "sms",
    "sms-voice",
    "snow-device-management",
    "snowball",
    "sns",
    "socialmessaging",
    "sqs",
    "ssm",
    "ssm-contacts",
    "ssm-incidents",
    "ssm-quicksetup",
    "ssm-sap",
    "sso",
    "sso-admin",
    "sso-oidc",
    "stepfunctions",
    "storagegateway",
    "sts",
    "supplychain",
    "support",
    "support-app",
    "swf",
    "synthetics",
    "taxsettings",
    "textract",
    "timestream-influxdb",
    "timestream-query",
    "timestream-write",
    "tnb",
    "transcribe",
    "transfer",
    "translate",
    "trustedadvisor",
    "verifiedpermissions",
    "voice-id",
    "vpc-lattice",
    "waf",
    "waf-regional",
    "wafv2",
    "wellarchitected",
    "wisdom",
    "workdocs",
    "workmail",
    "workmailmessageflow",
    "workspaces",
    "workspaces-thin-client",
    "workspaces-web",
    "xray",
]
ResourceServiceName = Literal[
    "cloudformation",
    "cloudwatch",
    "dynamodb",
    "ec2",
    "glacier",
    "iam",
    "opsworks",
    "s3",
    "sns",
    "sqs",
]
PaginatorName = Literal[
    "get_chat_controls_configuration",
    "list_applications",
    "list_attachments",
    "list_conversations",
    "list_data_accessors",
    "list_data_source_sync_jobs",
    "list_data_sources",
    "list_documents",
    "list_groups",
    "list_indices",
    "list_messages",
    "list_plugin_actions",
    "list_plugin_type_actions",
    "list_plugin_type_metadata",
    "list_plugins",
    "list_retrievers",
    "list_subscriptions",
    "list_web_experiences",
    "search_relevant_content",
]
RegionName = Literal[
    "af-south-1",
    "ap-east-1",
    "ap-northeast-1",
    "ap-northeast-2",
    "ap-northeast-3",
    "ap-south-1",
    "ap-south-2",
    "ap-southeast-1",
    "ap-southeast-2",
    "ap-southeast-3",
    "ap-southeast-4",
    "ap-southeast-5",
    "ap-southeast-7",
    "ca-central-1",
    "ca-west-1",
    "eu-central-1",
    "eu-central-2",
    "eu-north-1",
    "eu-south-1",
    "eu-south-2",
    "eu-west-1",
    "eu-west-2",
    "eu-west-3",
    "il-central-1",
    "me-central-1",
    "me-south-1",
    "mx-central-1",
    "sa-east-1",
    "us-east-1",
    "us-east-2",
    "us-west-1",
    "us-west-2",
]
